#<profile4xi profile = "11" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "test_arena4xi.py">
#<abstract4xi abstract = "tests arena4xi"/>
#<verify4xi verification = "10" target = "arena4xi.py"/>
#<contextualize4xi context = "arrayfunction4xi.py; lock4xi.py; manager4xi.py; pipe4xi.py; pool4xi.py; process4xi.py; queue4xi.py; value4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'main',
            'test_arena4xi',
            'set_trace4xi',                        
            'print_trace4xi']
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import mmap
import os
import sys
import threading                
import _thread
import _winapi   

from ctypes import Structure, c_double
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from arena4xi import Arena4Xi
from arrayfunction4xi import ArrayFunction4Xi 
from lock4xi import Lock4Xi
from manager4xi import Manager4Xi 
from pipe4xi import Pipe4Xi
from pool4xi import Pool4Xi
from process4xi import Process4Xi
from queue4xi  import Queue4Xi
from value4xi import Value4Xi
from valuefunction4xi import ValueFunction4Xi

from print4xi import Print4Xi
from pickle4xi import pickle4xi
from pickle2a4xi import Pickle2a4Xi
from pickle2b4xi import Pickle2b4Xi
from pickle2c4xi import Pickle2c4Xi
from pickle2d4xi import Pickle2d4Xi
from pickle2e4xi import Pickle2e4Xi
from pickle2f4xi import Pickle2f4Xi
from pickle2g4xi import Pickle2g4Xi
from pickle2h4xi import Pickle2h4Xi
from pickle2i4xi import Pickle2i4Xi
from pickle2j4xi import Pickle2j4Xi
from pickle2k4xi import Pickle2k4Xi
from pickle2l4xi import Pickle2l4Xi
from pickle2m4xi import Pickle2m4Xi
from pickle2n4xi import Pickle2n4Xi
from pickle2o4xi import Pickle2o4Xi
from pickle2p4xi import Pickle2p4Xi
from pickle2q4xi import Pickle2q4Xi
from pickle2r4xi import Pickle2r4Xi
from pickle2s4xi import Pickle2s4Xi
from pickle2t4xi import Pickle2t4Xi
from pickle2u4xi import Pickle2u4Xi
from pickle2v4xi import Pickle2v4Xi
from pickle2w4xi import Pickle2w4Xi
from pickle2x4xi import Pickle2x4Xi
from pickle2y4xi import Pickle2y4Xi
from pickle2z4xi import Pickle2z4Xi
from pickle2_4xi import Pickle2_4Xi      

from time4xi import time4xi

from xml_trace_sense4xi import xml_trace_sense4xi
from xml_trace_reason4xi import xml_trace_reason4xi
from xml_trace_ace4xi import xml_trace_ace4xi 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global t2xi 
global trace_object_count
global PickleKB4Xi

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
PickleKB4Xi = {
       'a': Pickle2a4Xi,
       'b': Pickle2b4Xi,
       'c': Pickle2c4Xi,
       'd': Pickle2d4Xi,
       'e': Pickle2e4Xi,
       'f': Pickle2f4Xi,
       'g': Pickle2g4Xi,
       'h': Pickle2h4Xi,
       'i': Pickle2i4Xi,
       'j': Pickle2j4Xi,
       'k': Pickle2k4Xi,
       'l': Pickle2l4Xi,
       'm': Pickle2m4Xi,
       'n': Pickle2n4Xi,
       'o': Pickle2o4Xi,
       'p': Pickle2p4Xi,
       'q': Pickle2q4Xi,
       'r': Pickle2r4Xi,
       's': Pickle2s4Xi,
       't': Pickle2t4Xi,
       'u': Pickle2u4Xi,
       'v': Pickle2v4Xi,
       'w': Pickle2w4Xi,
       'x': Pickle2x4Xi,
       'y': Pickle2y4Xi,
       'z': Pickle2z4Xi,
       '_': Pickle2_4Xi} 
#"
#"/>


# ----------------------------------------------------------------------------------------------------------
#<function4xi function = "set2trace4xi" usage = "setting trace using definitions in pickle4xi functions !
#">                      
# ----------------------------------------------------------------------------------------------------------    
def set2trace4xi():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    # print("(Step 0A/33) OF SET2TRACE4XI - STARTING SETTING TRACE BASED ON TRACE SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    # print("(Step 0B/33) OF SET2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>    
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('=' *33)
        # print("STARTING LETTER : ", key2pickledb)
        # print('=' *33)
   
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("STARTING DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
        # 
        keys2dictionary = sorted(dictionary2pickle.keys())
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
            # -------------------------------------------------------------------------------------     
            # print('~' *33)        
            object2pickle = key2dictionary        
            # print("STARTING OBJECT: ", object2pickle)
            # print('~' *33)         
            # pickle4xi(object2pickle)
            # print('~' *33)                  
            # print("PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            # ---------------------------------------------------------------------------------    
            # Mark those with NACK4XI to be traced !
            # ---------------------------------------------------------------------------------     
            if dictionary2pickle[key2dictionary] == 'NACK4XI':
                set_param2xi = True     
                key_param = object2pickle     
                t2xi.set_print_permission(key_param, set_param2xi)
                # print("(Step 2A/33) OF SET2TRACE4XI - MARKED TO BE TRACED OBJECT: ", object2pickle)                                
                # 
            else:
                pass  
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('~' *33)        
        # print("COMPLETED  DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print('=' *33)
    # print("COMPLETED LETTER : ", key2pickledb)
    # print('=' *33)
    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------
    print('=' *33)
    print("(Step 33/33) OF SET2TRACE4XI - COMPLETED SETTING TRACE BASED ON NACK4XI/ACK4XI SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print('=' *33)
#</function4xi> 

       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "deny2trace4xi" usage = "
#   deny trace using pickle4xi functions !
#">                      
# -------------------------------------------------------------------------------------------------    
def deny2trace4xi():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    print("(Step 01A/33) of DENY2TRACE4XI: STARTING DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print("(Step 01B/33) OF DENY2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02A/33) OF DENY2TRACE4XI - STARTING LETTER : ", key2pickledb)
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("(Step 02B/33) OF DENY2TRACE4XI - STARTING DICTIONARY: ", dictionary2pickle)
        keys2dictionary = sorted(dictionary2pickle.keys())
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
   
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
   
            object2pickle = key2dictionary        
            # print("(Step 02C/33) OF DENY2TRACE4XI - STARTING OBJECT: ", object2pickle)
            # pickle4xi(object2pickle)        
            # print("STEP: PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            
            # ---------------------------------------------------------------------------------    
            # ACK4XI = tested .i.e. NOT to be traced! 
            # ---------------------------------------------------------------------------------     
            set_param2xi = 'ACK4XI'     
            key_param = object2pickle     
            t2xi.set_print_permission(key_param, set_param2xi)
            # print("(Step 02D/33) OF DENY2TRACE4XI - MARKED TESTED AND NOT to be traced: ", object2pickle)
            
            dictionary2pickle[key2dictionary] = 'ACK4XI' 
                    
        
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
            # print('~' *33)              
            # print("(Step 02Z/33) OF DENY2TRACE4XI *** FAILED - ERROR IN PICKLING OBJECT - NOT TO BE TRACED: ", object2pickle)
            # print('~' *33) 
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02E/33) OF DENY2TRACE4XI - COMPLETED  DICTIONARY: ", dictionary2pickle)
        # 
        
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print("(Step 02F/33) OF DENY2TRACE4XI - COMPLETED LETTER : ", key2pickledb)
    # _, a ... z            
    print("(Step 033/33) OF SET2TRACE4XI - COMPLETED DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "tailor2trace4xi" usage = "
#   tailors trace 
#">                      
# -------------------------------------------------------------------------------------------------    
def tailor2trace4xi():
    global trace_object_count
    global PickleKB4Xi 
    global t2xi
 
    print("(Step 001A/33) OF TAILOR2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080> 
                         
    # ---------------------------------------------------------------------------------------------
    # Settings to tailor trace
    # ---------------------------------------------------------------------------------------------
    #<set4xi setting = "
    KB4Tailoring = {
        'Arena4Xi': 'NACK4TRACE'
        }                             
                
    default3trace = 'NACK4TRACE' # we do NOT want trace if object is not found! 
    #"/>
    
    # ---------------------------------------------------------------------------------------------
    # PROCESS KB4Tailoring
    # ---------------------------------------------------------------------------------------------
    keys2tailor = sorted(KB4Tailoring.keys())
    for key2tailor in keys2tailor:
        # ---------------------------------------------------------------------------------    
        # NACK4XI = NOT TESTED .I.E. TO BE TRACED! 
        # ---------------------------------------------------------------------------------     
        set_param2xi = 'NACK4XI'     
        key_param = key2tailor    
        t2xi.set_print_permission(key_param, set_param2xi)
        print("(Step 002A/33) OF TAILOR_TRACE4XI - MARKED TO BE TESTED: ", key2tailor)
        # 
        
    # -----------------------------------------------------------------------------------------    
    # EOF KEYS
    # -----------------------------------------------------------------------------------------     
    print("(Step 0033/33) OF TAILOR_TRACE4XI - COMPLETED  TAILORING: ", time4xi())
    #

    
#</function4xi>       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "print_trace4xi" usage = "
#   creates XML files
#">                       
# -------------------------------------------------------------------------------------------------    
def print_trace4xi(p2xi):
  

    # -------------------------------------------------------------------------------------------------
    # SENSE                        
    # -------------------------------------------------------------------------------------------------  
   
    context2sense = {
     'file_path4xi': '..\\..\\xml\\sense-test-arena4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi2.com/sense/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.yourdragonxi.org/web/lib/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Sensing of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Classes, methods and messages with context.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="Dragon4Xi#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Sensing Arena4Xi in Multiprocessing.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="sensed#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">Classes, Methods and Messages for Arena4Xi.</rdfs:comment>\n'}
      
    xml_trace_sense4xi(p2xi, context2sense)

    # -------------------------------------------------------------------------------------------------
    # REASON                         
    # -------------------------------------------------------------------------------------------------  
        
    context2reason = {
     'file_path4xi': '..\\..\\xml\\reason-test-arena4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi4.com/reason/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.dragonxi4.com/reason/sw4xi/python32/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Reasoning of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Operations</rdfs:comment>\n',
     'operation_comment4xi': '      <rdfs:comment xml:lang="en">Operations for Arena4Xi in Multiprocessing.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="reasoned#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Operations Arena4Xi in Multiprocessing.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="reason#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">reason</rdfs:comment>\n'}
       
    xml_trace_reason4xi(p2xi, context2reason)

    # -------------------------------------------------------------------------------------------------
    # ACE                         
    # -------------------------------------------------------------------------------------------------  
       
    context2ace = {
     'file_path4xi': '..\\..\\xml\\ace-test-arena4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi8.com/ace/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.dragonxi8.com/ace/sw4xi/python32/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Acing of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for Arena4Xi in Multiprocessing.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="ACE4Xi#0000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for Arena4Xi in Multiprocessing.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="ace#0000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">000000</rdfs:comment>\n'}   
    
    xml_trace_ace4xi(p2xi, context2ace)


    # -------------------------------------------------------------------------------------------------
    # end of print_trace4xi                        
    # -------------------------------------------------------------------------------------------------  
#</function4xi>
      

        
# -------------------------------------------------------------------------------------------------
#<function4xi function = "test-arena4xi" usage = "
#   testing arena4xi  
#"> 
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def test_arena4xi():
    global t2xi
    global trace_object_count    
        
    # --------------------------------------------------------------------------------------------- 
    # INITIALIZE TRACE
    # ---------------------------------------------------------------------------------------------        
    t2xi = Print4Xi()
    print("(Step 1/33) OF TEST_ARENA4Xi - SET T2XI TO: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000002B86EF0>
     
    set2trace4xi()                                                                                               # trace all classes and functions in the system
    deny2trace4xi()                                                                                              # deny trace for all classes and functions in the system
    tailor2trace4xi()                                                                                            # tailor trace for this test   
    
    try: 

        # -----------------------------------------------------------------------------------------
        # 
        # ----------------------------------------------------------------------------------------- 
        print("(STEP 1/70) OF TEST2ARENA4XI: STARTED ", time4xi())
        # 05:05:00 01/07/13 Pacific Standard Time
        
        # -----------------------------------------------------------------------------------------
        # CREATE
        # ----------------------------------------------------------------------------------------- 
        print("(STEP 2A/70) OF TEST2ARENA4XI - TRYING TO CREATE AND USE ARENA4XI OBJECT", time4xi())   
        length2xi = 256     
        try:
            arena2xi = Arena4Xi(length2xi)
            print("(STEP 2B/70) OF TEST2ARENA4XI - CREATED ARENA4XI  OBJECT: ", arena2xi) 
            # <arena4xi.Arena4Xi object at 0x0000000002A9F080>
            print("(STEP 2C/70) OF TEST2ARENA4XI - LENGTH OF ARENA: ", arena2xi.size)
            # 256
            print("(STEP 2D/70) OF TEST2ARENA4XI - NAME OF ARENA: ", arena2xi.name)
            # pym-2260-0
            
            buffer2xi = arena2xi.buffer
            print("(STEP 2E/70) OF TEST2ARENA4XI - BUFFER OF ARENA: ", buffer2xi)
            # <mmap.mmap object at 0x0000000003A62818>           
            print("(STEP 2F/70) OF TEST2ARENA4XI - STATE OF ARENA: ", arena2xi._state)
            # (256, 'pym-2260-0')
            print("(STEP 2G/70) OF TEST2ARENA4XI - COUNTER OF ARENA: ", Arena4Xi._counter)
            # count(1)          
        except:
            print("(STEP 2Z/70) OF TEST2ARENA4XI *** FAILED TO CREATE AND USE ARENA4XI OBJECT ", time4xi())
        
        # -----------------------------------------------------------------------------------------
        # MEMORY MAP WITH EXAMPLE http://docs.python.org/py3k/library/mmap.html
        # ----------------------------------------------------------------------------------------- 
        print("(STEP 3A/70) OF TEST2ARENA4XI - TRYING TO MEMORY MAP EXAMPLE  ", time4xi())   
        try:
            with open("hello.txt", "wb") as f:
                f.write(b"Hello Python!\n")

            with open("hello.txt", "r+b") as f:
                # memory-map the file, size 0 means whole file
                map = mmap.mmap(f.fileno(), 0)
                # read content via standard file methods
                print(map.readline())  
                # b"Hello Python!\n"
                # read content via slice notation
                print(map[:5])  
                # b"Hello"
                # update content using slice notation;
                # note that new content must have same size
                map[6:] = b" world!\n"
                # ... and read again using standard file methods
                map.seek(0)
                print(map.readline())  
                # b"Hello  world!\n"
                # close the map
                map.close()
                print("(STEP 3B/70) OF TEST2ARENA4XI - PERFORMED MEMORY MAP EXAMPLE  ", time4xi()) 
                # 05:05:00 01/07/13 Pacific Standard Time
        except:
            print("(STEP 3Z/70) OF TEST2ARENA4XI *** FAILED TO PERFORM MEMORY MAP EXAMPLE ", time4xi())
                    
        # -----------------------------------------------------------------------------------------
        # FILE OPERATIONS WITH IMAGE 
        # -----------------------------------------------------------------------------------------         
        print("(STEP 4A/70) OF TEST2ARENA4XI - TRYING FILE OPERATIONS WITH IMAGE FILE ", time4xi())   
        # 05:05:00 01/07/13 Pacific Standard Time
        try:        
            path2image = '..//..//..//..//web//images//png//dragonxi.png'
            file2xi = open(path2image)
 
            print("(STEP 4B1/70) OF TEST2ARENA4XI - FILENO: ", file2xi.fileno( ))  
            # 3
            print("(STEP 4B2/70) OF TEST2ARENA4XI - MODE: ", file2xi.mode)
            # r
            print("(STEP 4B2/70) OF TEST2ARENA4XI - NAME: ", file2xi.name)
            # ..//..//..//..//web//images//png//dragonxi.png 
            
            offset2xi = 10
            file2xi.seek(offset2xi)
            print("(STEP 4B3/70) OF TEST2ARENA4XI - PERFORMED SEEK WITH OFFSET: ", offset2xi)
            # 10
            
            file2xi.close()
            print("(STEP 4B70/70) OF TEST2ARENA4XI - CLOSED IMAGE FILE: ", path2image)
            # ..//..//..//..//web//images//png//dragonxi.png  
        except:
            print("(STEP 4Z/70) OF TEST2ARENA4XI *** FAILED TO PERFORM FILE OPERATIONS WITH IMAGE FILE: ", path2image)
        
        # -----------------------------------------------------------------------------------------
        # MEMORY MAP WITH PNG IMAGE DRAGONXI
        # ----------------------------------------------------------------------------------------- 
        print("(STEP 5A/70) OF TEST2ARENA4XI - TRYING TO OPEN FOR MEMORY MAP DRAGONXI ", time4xi())    
        # 05:05:00 01/07/13 Pacific Standard Time
        try:
            path2image = '..//..//..//..//web//images//png//dragonxi.png'
            file2xi = open(path2image)
            print("(STEP 5B1/70) OF TEST2ARENA4XI - OPENED FILE DRAGON2XI: ", file2xi)  
            # <_io.TextIOWrapper name='..//..//..//..//web//images//png//dragonxi.png' mode='r' encoding='cp1252'> 
            
            fileno2xi = file2xi.fileno()
            print("(STEP 5B2/70) OF TEST2ARENA4XI - FILENO OF DRAGON2XI: ", fileno2xi)  
            # 3
             
        except:
            print("(STEP 5Z1/70) OF TEST2ARENA4XI *** FAILED TO OPEN FOR MEMORY MAP DRAGONXI ", time4xi())
                         
        print("(STEP 6C1/70) OF TEST2ARENA4XI - TRYING TO MEMORY MAP DRAGONXI ", time4xi()) 
        # 05:05:00 01/07/13 Pacific Standard Time
        try:    
            map2xi = mmap.mmap(fileno2xi, 0)
                  
            print("(STEP 6C2/70) OF TEST2ARENA4XI - MAPPED DRAGONXI ", time4xi())
            # 
            try:                
                map2xi.seek(0)
                print("(STEP 6C3/70) OF TEST2ARENA4XI - SEEKED MAPPED DRAGONXI ", dragon2xi)
                map2xi.close()
            except:
                map2xi.close()
                
        except:
            print("(STEP 6Z1/70) OF TEST2ARENA4XI *** FAILED TO MEMORY MAP DRAGONXI ", time4xi()) 
            # *** FAILED TO MEMORY MAP DRAGONXI  05:05:00 01/07/13 Pacific Standard Time
            print("(STEP 6Zz/70) OF TEST2ARENA4XI ** ONLY TEXT FILES CAN BE MAPPED ** ", time4xi())                 
        # -----------------------------------------------------------------------------------------
        # SENSE
        # ----------------------------------------------------------------------------------------- 
        print("(STEP 67A/70) OF TEST2ARENA4XI - TRYING TO SENSE ARENA4XI OBJECT", time4xi()) 
                    
        try:
            print("(STEP 67B/70) OF TEST2ARENA4XI - SENSED ARENA4XI OBJECT: ", arena2xi.sense()) 
            # {'inheritance-of-arena2xi': 'object-inheriting-by-arena2xi-of-Arena4Xi', 'object': <arena4xi.Arena4Xi object at 0x00000000039E0160>}               
        except:
            print("(STEP 67Z/70) OF TEST2ARENA4XI *** FAILED TO SENSE ARENA4XI OBJECT ", time4xi())
    
        
        # -----------------------------------------------------------------------------------------
        # REASON
        # ----------------------------------------------------------------------------------------- 
        print("(STEP 68A/70) OF TEST2ARENA4XI - TRYING TO REASON ARENA4XI OBJECT", time4xi()) 
                    
        try:
            print("(STEP 68B/70) OF TEST2ARENA4XI - REASONED ARENA4XI OBJECT: ", arena2xi.reason()) 
            # {'object-reason-object4xi': <arena4xi.Arena4Xi object at 0x00000000039E0160>}               
        except:
            print("(STEP 68Z/70) OF TEST2ARENA4XI *** FAILED TO REASON ARENA4XI OBJECT ", time4xi())               

        
        # -----------------------------------------------------------------------------------------
        # ACE
        # ----------------------------------------------------------------------------------------- 
        print("(STEP 69A/70) OF TEST2ARENA4XI - TRYING TO ACE ARENA4XI OBJECT", time4xi()) 
                    
        try:
            print("(STEP 69B/70) OF TEST2ARENA4XI - ACED ARENA4XI OBJECT: ", arena2xi.ace()) 
            # {'object8xi': <arena4xi.Arena4Xi object at 0x00000000039E0160>}               
        except:
            print("(STEP 69Z/70) OF TEST2ARENA4XI *** FAILED TO ACE ARENA4XI OBJECT ", time4xi())               
        
        # -----------------------------------------------------------------------------------------
        # COMPLETED 
        # ----------------------------------------------------------------------------------------- 
        print("(STEP 70A/70) OF TEST2ARENA4XI - COMPLETED TESTING OF ARENA4XI OBJECT", time4xi()) 

    except:
        print("(STEP 70Z/70) OF TEST2ARENA4XI *** FAILED TO TEST ARENA4XI OBJECT ", time4xi())  
    
    finally:        
            
        # ---------------------------------------------------------------------------------------------    
        # Print Trace
        # ---------------------------------------------------------------------------------------------     
        print_trace4xi(t2xi)        
   
         
#</function4xi>
        
# -------------------------------------------------------------------------------------------------
#<function4xi function = "main" usage = "
#   main function to test arena4xi
#"> 
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def main():

    print('=' *33)
    print("(SENSING IT WITH YOURDRAGONXI!")  
    print('=' *33)
        
    test_arena4xi()
    
    print('=' *33)
    print("(SENSED IT WITH YOURDRAGONXI!")    
    print('=' *33) 
                          
#</function4xi>
 

         

# -------------------------------------------------------------------------------------------------
#                               
# -------------------------------------------------------------------------------------------------
if __name__ == '__main__':
    main()
    
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_arena4xi.txt
#   sense-test-arena4xi.xml
#   reason-test-arena4xi.xml
#   ace-test-arena4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 


#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of test_arena4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
